#!/usr/bin/perl
open SHREC, "<shrec.id";
open RASMOL, ">shrec.cmd";
while (<SHREC>) {
  chomp;
  ($scop, $out, $pdbid, $s) = split(' ', $_);
 
  # pdb: source directory 
  $pdb="pdb/".$pdbid.".pdb"; # 1ash -> pdb/1ash.pdb
  # out: result directory 
  $out="out/".substr($out, 1).".pdb"; # d1ash -> 1ash.pdb
# -
  if ($s =~ /^-$/) { $sel = ":"; }
# A:
  elsif ($s =~ /^(\S):$/) { $sel = ":$1"; }
# 100-200
  elsif ($s =~ /^(\d+)-(\d+)$/) { $sel = "$1-$2:"; }
# A:100-200
  elsif ($s =~ /^(\S):(\d+)-(\d+)$/) { $sel = "$2-$3:$1"; }
# 100-200,300-400
  elsif ($s =~ /^(\d+)-(\d+),(\d+)-(\d+)$/) { $sel = "$1-$2:,$3-$4:"; }
# A:100-200,A:300-400
  elsif ($s =~ /^(\S):(\d+)-(\d+),(\S):(\d+)-(\d+)$/) { $sel = "$2-$3:$1,$5-$6:$4"; }
  
  # print `./format.sh $a.$b $pdb $sel $out | rasmol -nodisplay`;

  $hasModel=`grep -c ^ENDMDL $pdb`; chomp($hasModel);
  if ($hasModel != 0) { $sel = $sel."/1"; }
  
  $rasmol = "load pdb $pdb\n";
  $rasmol = $rasmol."select protein and not (hydrogen or hetero) and $sel\n";
  $rasmol = $rasmol."save pdb $out\nzap\n\n";

  print RASMOL $rasmol;
}
print RASMOL "exit\n";
close(RASMOL);
close(SHREC);

`cat shrec.cmd | rasmol -nodisplay > shrec.log`;

print "done.\n\nPlease check shrec.cmd shrec.log and generated pdb files.\n\n";
